#!/bin/env python3

import parsimonious, sys

grammar = parsimonious.Grammar("""
	sent = prop
	prop = det adj? nom adj? verb
	det = tok"/"lemma"/DET"
	adj = tok"/"lemma"/ADJ"
	nom = tok"/"lemma"/NOM"
	verb = tok"/"lemma"/VER"
	word = tok"/"lemma"/"pos
	tok = ~r"[^/]*"
	lemma = ~r"[^/]*"
	pos = ~r"[^/]*"
""")

for sent in sys.stdin:
	sent = sent.strip()
	print('INTPUT:', sent)
	senttoks = sent.split(' ')
	for i in range(len(senttoks)):
		sentpart = ' '.join(senttoks[i:])
		try:
			sentpartmatch = grammar.match(sentpart)
			print('MATCH: at token', i)
			print(sentpartmatch)
		except parsimonious.exceptions.ParseError:
			pass
